﻿
using Infragistics.Windows;
using Infragistics.Windows.Automation.Peers.DataPresenter;
using Infragistics.Windows.DataPresenter;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Automation.Peers;
using System.Windows.Automation.Provider;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace test
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            xdg.DataContext = Data.GetData(100, 1, 10);
        }

        private void xdg_RecordExpanded(object sender, Infragistics.Windows.DataPresenter.Events.RecordExpandedEventArgs e)
        {
            GroupByRecord groupRecord = e.Record as GroupByRecord;
            if (null != groupRecord && groupRecord.IsExpanded)
            {
                GroupByRecordPresenter groupRecordPresenter = (GroupByRecordPresenter)GroupByRecordPresenter.FromRecord(groupRecord);
                foreach (var item in (groupRecordPresenter.Parent as GridViewPanelFlat).ChildElements)
                {
                    if ((item.GetType() == typeof(GroupByRecordPresenter) && (item as GroupByRecordPresenter).Record.Index == groupRecordPresenter.Record.Index - 1)) //presenter above
                        (item as GroupByRecordPresenter).Margin = new Thickness(0, 0, 0, 15);

                    else if ((item.GetType() == typeof(GroupByRecordPresenter) && (item as GroupByRecordPresenter).Record.Index == groupRecordPresenter.Record.Index + 1)) //presenter below
                        (item as GroupByRecordPresenter).Margin = new Thickness(0, 15, 0, 0);
                }
            }
        }

        private void xdg_RecordCollapsed(object sender, Infragistics.Windows.DataPresenter.Events.RecordCollapsedEventArgs e)
        {
            GroupByRecord groupRecord = e.Record as GroupByRecord;
            GroupByRecordPresenter groupRecordPresenter = (GroupByRecordPresenter)GroupByRecordPresenter.FromRecord(groupRecord);
            foreach (var item in (groupRecordPresenter.Parent as GridViewPanelFlat).ChildElements)
            {
                if (item.GetType() == typeof(GroupByRecordPresenter)) //presenter above
                    (item as GroupByRecordPresenter).Margin = new Thickness(0, 0, 0, 2);
            }
        } 
    }



    public class MyConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            return Binding.DoNothing;
        }
        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }



    public class Data : INotifyPropertyChanged
    {
        private int high;
        private int value;
        private string label;

        public string Label
        {
            get { return label; }
            set
            {
                label = value;
                PropChanged("Label");
            }
        }

        public int High
        {
            get { return high; }
            set
            {
                high = value;
                PropChanged("High");
            }
        }

        public int Value
        {
            get { return value; }
            set
            {
                this.value = value;
                PropChanged("Value");
            }
        }

        public static ObservableCollection<Data> GetData(int points, int rangeStart, int rangeEnd)
        {
            ObservableCollection<Data> data = new ObservableCollection<Data>();
            Random r = new Random();
            for (int i = 0; i < points; i++)
            {
                data.Add(new Data
                {
                    Label = "Item " + r.Next(1,20),
                    High = r.Next(rangeStart, rangeEnd),
                    Value = r.Next(rangeStart, rangeEnd)
                });
            }

            return data;
        }

        public event PropertyChangedEventHandler PropertyChanged;

        public void PropChanged(string name)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(name));
        }
    }




}
